/*

Politecnico di Torino - esame Informatica (12BHD)
Prof. Antonio Lioy - corso BOU-CASA - AA 2010-2011

Una possibile soluzione del tema d'esame di programmazione del 22/07/2011

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define FILE_TS "time.dat"
#define MAX_CHAR_RIGA 127
#define NGIORNI 365

#define BOOLEAN int
#define FALSE 0
#define TRUE (!FALSE)


int main (int argc, char *argv[])
{
   int k; // valore massimo minuti lavorabili in un giorno

   FILE *f; // file handle associata al file del timesheet
   char riga[MAX_CHAR_RIGA+1]; // caratteri costituenti la riga attuale 
   int giorno, durata; // giorno e durata della riga attuale
   int r = 0; // n. riga attualmente considerata

   // flag per sapere se il limite e' stato superato almeno una volta
   BOOLEAN limite_superato = FALSE;
 
   // vettore per memorizzare i minuti lavorati in ciascun giorno
   // non usiamo il giorno 0 ma solo quelli 1...365
   // inoltre tutti valori non inizializzati sono posti pari zero (ma bisogna indicarne almeno uno)
   unsigned minlav[NGIORNI+1] = { 0 };

   // controllo degli argomenti

   if (argc != 2) {
      fprintf (stderr, "errore - introdurre limite K\n");
      exit (1);
   }
   if (sscanf(argv[1], "%d", &k) != 1) {
      fprintf (stderr, "errore - il parametro %s non  un numero intero\n", argv[1]);
      exit (1);
   }

   // apertura del file contenente il timesheet

   if ((f=fopen(FILE_TS,"r")) == NULL) {
      fprintf (stderr, "errore - impossibile aprire il file %s in lettura\n", FILE_TS);
       exit (1);
   }

   // lettura delle singole righe del file

   while (fgets(riga,MAX_CHAR_RIGA,f) != NULL) {
      r++;
      // estrazione dati che interessano e controllo dei loro valori
      if (sscanf(riga, "%d %*s %d", &giorno, &durata) != 2) {
         fprintf (stderr, "avviso - riga %d in formato errato: ignorata\n", r) ;
         continue;
      }
      if (giorno<1 || giorno>365) {
         fprintf (stderr, "avviso - riga %d con giorno errato (%d): ignorata\n", r, giorno) ;
         continue;
      }
      if (durata < 1) {
         fprintf (stderr, "avviso - riga %d con durata errata (%d): ignorata\n", r, durata) ;
         continue;
      }
      // aggiungo la durata al giorno attuale e controllo se e' stato superato il limite
      minlav[giorno] += durata;
      if (minlav[giorno] > k)
        limite_superato = TRUE;
   }

   // chiusura del file

   if (fclose(f) != 0)
      fprintf (stderr, "avviso - chiusura del file %s non riuscita\n", FILE_TS);

   // stampa del risultato

   if (! limite_superato)
      printf ("Dati nel file corretti\n");
   else
   {  // esamino ciascun giorno e segnalo quelli che superano il limite
      int g;
      printf ("Il limite di %d minuti e' stato superato nei seguenti giorni:\n", k);
      for (g=1 ; g<=365 ; g++)
         if (minlav[g] > k)
            printf ("- giorno %d (%d minuti)\n", g, minlav[g]);
   }

   // fine del programma

   return 0;
}
